import sys
import pandas as pd
import csv
import numpy as np
pd.set_option('display.max_rows', None)

## only print identities until sum probability exceeds this
prob_threshold=0.8;

#python3 csvtolatex.py testsout.csv colstolatex colstolatexi
## the csv output from bayesactsim is the first argument
fifname = sys.argv[1];
## a text file with, on each line, a column name you want printed in your latex table colstolatex 
colfname = sys.argv[2];
colifname = sys.argv[3];   ## may be omitted (and this line commented out) if both row are the same
los=[]
colf=open(colfname,"r");
colname=colf.readline().strip()
while colname:
    los=los+[colname];
    colname=colf.readline().strip()

colf.close();

losi=[]
colif=open(colifname,"r");
coliname=colif.readline().strip()
while coliname:
    losi=losi+[coliname];
    coliname=colif.readline().strip()

colif.close();


## output this file to e.g. coalminer2.tex and then pdflatex coalminer.tex includes that


df=pd.read_csv(fifname,sep=',',skipinitialspace=True);

numels=df.shape

for i in range(0,numels[0]):
    checkprob=False
    doingprob=False
    haveaction=0
    lostodo=losi
    ## evvery secondrow is different
    if i%2==0:
        lostodo=los
    for colname in lostodo:
        if colname in df:
            if colname.endswith("name"):
                if haveaction==0:
                    if df[colname][i]=="hank":
                        haveaction=+1;
                    else:
                        haveaction=-1;
                
            #haveaction>0 means the first agent is the one acting this round, so is the one specified first in the CSV
            ## otherwise it is the second one
            spl=str(df[colname][i]).split(',')
            if colname.endswith("probabilities"):
                checkprob=True   ## the next column needs to be cut off at the same point
                doingprob=True
                sumspl=0.0
                for j in range(0,len(spl)):
                    sumspl = sumspl + float(spl[j])
                    if sumspl >= prob_threshold:
                        break
                    
                maxj=j+1
            elif checkprob:
                checkprob=False
                #maxj stays the same
            else:
                doingprob=False
                maxj=len(spl)
                
                
            ##print("\begin{tabular}{"+len(spl)*"c"+"}");
            if doingprob:
                print("\\begin{tabular}{l}",end="  ")
                for j in range(0,maxj):
                    if (checkprob):
                        print("{:.1f}".format(float(spl[j])),end="\\\\")
                    else:
                        print(spl[j],end="\\\\")
                print("\\end{tabular}",end=" & ")

            if colname.endswith("total") or colname.endswith("dist"):
                print("{:.1f}".format(df[colname][i]),end=" ");
                if colname != lostodo[-1]:
                    print(" & ",end="")
            elif "behaviour" in colname:
                print("\\begin{tabular}{c} "+df[colname][i]+"\\\\ ",end="");
                if haveaction>0:
                    print("$\\rightarrow$",end="")
                else:
                    print("$\\leftarrow$",end="")
                print("\end{tabular}",end=" & ");
            elif not haveaction:
                print(df[colname][i],end=" & ");
        else:
            print(colname+" not in df")
    print("\\\\ \hline")

