/************************************************************************************************#
#                           Bayesian Affect Control Theory (V2)                                  #
#************************************************************************************************#
#  Author: Jesse Hoey  jhoey@cs.uwaterloo.ca   http://www.cs.uwaterloo.ca/~jhoey                 #
#  Date  : March 2017                                                                            #
#  Copyright (C) 2017  Jesse Hoey                                                                #
#                                                                                                #
#  Use for research purposes only.                                                               #
#  Do not re-distribute without written permission from the author                               #
#  Any commerical uses strictly forbidden.                                                       #
#  This program is distributed WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                          #
#                                                                                                #
#  See README for details                                                                        #
#  See bayesact.ca for details and instructional videos                                          # 
#************************************************************************************************#
# include file for the image writer
#************************************************************************************************/
#ifndef __IMAGEWRITER
#define __IMAGEWRITER
#include "png.h"
#include "math.h"
#include "fvarsample.h"

// maximum size to which a dot can grow ...
#define MAX_DOT_SIZE 10
// minimum color value for images to keep red and blue distinguished
#define MIN_COL 128
// 110 = 6 is e vs p
// 101 = 5 is e vs a
// 011 = 3 is p vs a
typedef enum {
  EP=6,
  EA=5,
  PA=3,
} pair_type;


void save_ppm(char *path, unsigned char *data, int ncols, int nrows);
int write_sample_image(char *basefname, int dyad, int iteration, int ncols, int nrows, sample *samples, int numsamples, pair_type);


#endif
